# Pokéscreader for SV

ポケットモンスタースカーレット・バイオレット
(以下, ポケモン SV) 向けスクリーン読み取りツール.

[OBS Studio](https://obsproject.com/ja) からポケモン SV の対戦画面を読み取り,
外部の音声合成アプリを通じて情報を読み上げます. 用途として以下を想定しています.

- 視覚情報が使えないプレイヤーのプレイング補助
- 視覚情報だけでは情報把握が難しい対戦初心者のプレイング補助
- 対戦配信における音声情報の拡充によるコンテンツ強化

このドキュメントは, バージョン固有な情報を記録する目的で記述されており,
必要最小限の情報のみを記述しています. 機能や導入手順の詳しい解説は
[公式サイト](https://takosavi.net/pokescreader-sv/)
をご確認ください.

## 機能

このバージョンで実装されている機能は次の通りです.

### 自動で起動する機能

#### シーン遷移通知

- 選出開始
- 選出終了
- 指示開始

#### 自動読み上げ

- 相手チーム
- 味方チーム (設定時のみ)
- 相手 HP 割合
- 味方 HP 現在値, 割合
- ログメッセージ
- テラスタイプ

### 手動で操作する機能

- 相手チーム確認 (O キー)
- 相手チームのタイプ確認 (T キー)
- 相手 HP 確認 (H キー)
- 味方 HP 確認 (A キー)
- 技を読み取り (M キー, 技選択画面またはポケモン選択画面のみ)
- カーソル読み取り (C キー, 選出画面, 指示画面, 技選択画面, ポケモン選択画面のみ)
- スクリーンショット保存 (1 キー)
- 設定画面を開く (Ctrl + コンマキー)

## 把握している不具合

- シーン遷移通知
    - 技選択で使用できない技 (「ちょうはつ」やこだわりアイテムで制限されている場合など)
      を連打すると, 「指示開始」 と通知されることがあります.
- 相手チーム読み上げ
    - 実機ではなくシミュレーションでの確認にすぎませんが, 次の読み間違いが発生する可能性があります.
        - アルセウス ノーマル以外 → アルセウス ノーマル
        - イキリンコ グリーンフェザー以外 → イキリンコグリーンフェザー
        - ナミイルカ → イルカマン
- 味方チーム読み上げ
    - 6 匹ではないチームを読み上げる際,
      ポケモンが存在しない個所で不正なポケモン名を読み上げます.
- 相手 HP 割合読み上げ
    - 食べ残しの回復ダメージなど, HP ゲージエフェクトの表示時間が極めて短い場合,
      HP 割合の読み上げができなかったり, 数値が不正確になったりすることがあります.
    - 高頻度にダメージが発生する連続技を使うと, 発話量が多すぎて詰まることがあります.
- テラスタイプ読み上げ
    - 「テラスタイプドラゴン」を「テラスタイプひこう」と頻繁に間違える傾向があります.
    - 「テラスタイプこおり」を他のタイプと混同することがあります. 
    - カバルドンなど, 前にせり出したポケモンのテラスタイプ判定が不安定になることがあります.
- 技読み上げ
    - Windows OCR 使用時, 「のろい」の読み上げが失敗することがあります.
    - Windows OCR 使用時, 「さいきのいのり」の PP 読み上げが失敗することがあります.
- カーソル読み上げ
    - 選出画面
        - 一部のポケモンで, ポケモン名が安定しないことがあります.
    - 指示画面
      　- サポート外ですが, 通信対戦以外では正しくない位置を読み上げることがあります.
    - 技選択画面
        - 残り PP が 0 になった技を選択しているとき, 読み上げが失敗します.
    - ポケモン選択画面
        - 一部のポケモンで, ポケモン名が安定しないことがあります.
        - 技を選択しているとき, 読み上げが失敗します.

## 免責事項

テンプレなお約束ですが, 本アプリの使用によって生じた不利益には関知しません. 自己責任でご利用ください.
特に, 通知内容はできるだけ正確になるよう努めていますが, 間違いを起こすこともあります.
あくまでも参考情報として扱ってください.

## 作者

もち

- X: [@takosavi](https://x.com/takosavi)
- Blog: https://takosavi.hatenablog.com/
- Twitch: https://www.twitch.tv/mochitakosavi
